(function () {
    'use strict';

    /// <reference path="../node_modules/web-ext-types/global/index.d.ts" />
    const root = browser.runtime.getURL('');
    const previousRequests = new Map();
    browser.runtime.onMessage.addListener((message, sender) => {
        if (!isOurMessage(message))
            return undefined;
        const [, ...url] = message.url.split(root);
        const { id } = sender.tab;
        const { frameId } = sender;
        const key = `${id}-${frameId}`;
        const previousReq = Promise.resolve(previousRequests.get(key));
        const p = previousReq.finally(() => browser.tabs.executeScript(id, { frameId, file: url.join(root) }).then(() => { }, (e) => [e.message, e.stack]));
        previousRequests.set(key, p);
        return p;
    });
    function isOurMessage(o) {
        // @ts-ignore
        const parentURL = typeof o.parentURL;
        return (typeof o === 'object' &&
            // @ts-ignore
            (o === null || o === void 0 ? void 0 : o.key) === 'system-js-loader' &&
            // @ts-ignore
            typeof o.url === 'string' &&
            (parentURL === 'string' || parentURL === 'undefined'));
    }

}());
//# sourceMappingURL=background-script.js.map
